summaryrefslogtreecommitdiff
path: root/tests/tail-2/pipe-f
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2009-09-07 22:10:10 +0200
committerJim Meyering <meyering@redhat.com>2009-09-07 23:19:56 +0200
commitaf6436559c2954d7f35b7fec29dfcbaa4ebdc03b (patch)
tree4c5d53442d729d663c15809899bd5c03bdf13b6d /tests/tail-2/pipe-f
parentfd9750b0ffb691d2ad97551eada5c2802df3c805 (diff)
downloadcoreutils-af6436559c2954d7f35b7fec29dfcbaa4ebdc03b.tar.xz
tail: ignore -f for piped-stdin, as POSIX requires
* src/tail.c (main): Tailing a pipe "forever" is not useful, and POSIX specifies that tail ignore the -f when there is no file argument and stdin is a FIFO or pipe. So we do that. In addition, GNU tail excludes "-" arguments from the list of files to tail forever, when the associated file descriptor is connected to a FIFO or pipe. Before this change, ":|tail -f" would hang. Reported by Ren Yang and Ulrich Drepper. * tests/tail-2/pipe-f: Test for this. * tests/tail-2/pipe-f2: Ensure tail doesn't exit early for a fifo. * tests/Makefile.am (TESTS): Add these tests. * NEWS (POSIX conformance): Mention it.
Diffstat (limited to 'tests/tail-2/pipe-f')
-rwxr-xr-xtests/tail-2/pipe-f32
1 files changed, 32 insertions, 0 deletions
diff --git a/tests/tail-2/pipe-f b/tests/tail-2/pipe-f
new file mode 100755
index 000000000..b9f6ae389
--- /dev/null
+++ b/tests/tail-2/pipe-f
@@ -0,0 +1,32 @@
+#!/bin/sh
+# ensure that :|tail -f doesn't hang, per POSIX
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+fail=0
+echo foo | timeout 2 tail -f -c3 > out || fail=1
+echo oo > exp || fail=1
+
+compare out exp || fail=1
+
+Exit $fail